import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getToken,setToken } from '@/utils/auth'
import { isRelogin } from '@/utils/request'

NProgress.configure({ showSpinner: false })

const whiteList = ['/login', '/register']

router.beforeEach((to, from, next) => {
  NProgress.start()

  const path = to.path;
  const token = to.query.Authorization;
  if (path.indexOf('auth') != -1 && token) {
    setToken(token);
    next({ path: '/' });
  }
  if (getToken()) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    if (to.path === '/login') {
      next({ path: '/' })
      NProgress.done()
    } else {
      if (store.getters.roles.length === 0) {
        isRelogin.show = true
        // 判断当前用户是否已拉取完user_info信息
        store.dispatch('GetInfo').then(() => {
          isRelogin.show = false
          store.dispatch('GenerateRoutes').then(accessRoutes => {
            // 根据roles权限生成可访问的路由表
            router.addRoutes(accessRoutes) // 动态添加可访问路由表
            //store.dispatch("getReviewNumber"); //初始化评估考察代办数量
            //store.dispatch("getApprovalNumber"); //初始化项目立项代办数量
            //store.dispatch("getInvestigateNumber"); //初始化尽职背调代办数量
            //store.dispatch("getDecisionNumber"); //初始化项目投决代办数量
            store.dispatch("getMyTaskInvestOppNumber"); //初始化项目机会代办数量
            store.dispatch("getMyTaskApprovalNumber"); //初始化项目立项代办数量
            store.dispatch("getMyTaskInvestigateNumber"); //初始化项目背调代办数量
            store.dispatch("getMyTaskDecisionNumber"); //初始化项目投决代办数量
            store.dispatch("getMyTaskTerminationNumber"); //初始化项目终止代办数量
            //next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
            next({ path: '/' })

          })
        }).catch(err => {
          store.dispatch('LogOut').then(() => {
            location.href = 'http://dgt.dgtis.com/oneportal/login';
            /*Message.error(err)
            next({ path: '/' })*/
          })
        })
      } else {
        next()
      }
    }
  } else {
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
     // next(`/login?redirect=${encodeURIComponent(to.fullPath)}`) // 否则全部重定向到登录页
      location.href = 'http://dgt.dgtis.com/oneportal/login';
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  NProgress.done()
})
